
/*  A Bison parser, made from ..\..\..\src\cfg.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	_LOGFILE	257
#define	_LOGLEVEL	258
#define	_NODELIST	259
#define	_INDEXFILE	260
#define	_NODELISTPATH	261
#define	_ADDRESS	262
#define	_SYSOPNAME	263
#define	_USEOWNZONE	264
#define	_FORCEINTL	265
#define	_LOOPSTR	266
#define	_SCANDIR	267
#define	_MASK	268
#define	_SMASK	269
#define	_PMASK	270
#define	_BODYMASK	271
#define	_SBODYMASK	272
#define	_PBODYMASK	273
#define	_KLUDGEMASK	274
#define	_SKLUDGEMASK	275
#define	_PKLUDGEMASK	276
#define	_ACTION	277
#define	_MAXAGE	278
#define	_BADMESSAGES	279
#define	_NOLOGIGNORE	280
#define	_AKA	281
#define	_SKIPHIDDENFILES	282
#define	_FILEINBOUND	283
#define	_OUTBOUND	284
#define	_ADDTONULLPKT	285
#define	_TEMPMAIL	286
#define	_TRAFFICLOG	287
#define	_PASSWORD	288
#define	_UTC	289
#define	_ORIGIN	290
#define	_TEARLINE	291
#define	_INCLUDE	292
#define	_APKTDIR	293
#define	_CHECKPOINTS	294
#define	_SETVIAALWAYS	295
#define	_CREATEMISSINGBASE	296
#define	_USENEWVIA	297
#define	_MAXATTACHSIZE	298
#define	_SEMAPHORE	299
#define	_KILLROUTEDMESSAGE	300
#define	_MAXNODELISTAGE	301
#define	_SOFTCHECKINNODELIST	302
#define	_TIMESTAMPFILE	303
#define	_TRAFFICLOGTEMPLATE	304
#define	_CRLF	305
#define	_SKIP	306
#define	_DELETE	307
#define	_EXIT	308
#define	_MOVE	309
#define	__EOF	310
#define	_STRING	311
#define	_BEFOREROUTE	312
#define	_AFTERROUTE	313
#define	_DIGIT_	314
#define	_RENUMBER	315
#define	_UNPACK	316
#define	_DAILY	317
#define	_WEEKLY	318
#define	_FLAG	319
#define	_NEVER	320
#define	_HARD	321
#define	_SOFT	322
#define	_ALWAYS	323
#define	_ADDNOTE	324
#define	_COPY	325
#define	_REWRITE	326
#define	_IGNORE	327
#define	_DISPLAY	328
#define	_DELFILE	329
#define	_NEWMSG	330
#define	_WRITEFILE	331
#define	_APPENDTOFILE	332
#define	_CALL	333
#define	_ROUTE	334
#define	_POLL	335
#define	_DELETEATTACH	336
#define	_CHANGEPATH	337
#define	_MOVEATTACH	338
#define	_COPYATTACH	339
#define	_SPLIT	340
#define	_RECODE	341
#define	_HOLD	342
#define	_CRASH	343
#define	_DIRECT	344
#define	_NORMAL	345
#define	LEXERR	346



#define YYDEBUG 0
/* #define YYERROR_VERBOSE */

#include <stdlib.h>
#ifdef __WATCOMC__
   #include <malloc.h>
#endif
#include "msg.hpp"
#include "outbound.hpp"
#include "fidoaddr.h"
#include "vars.hpp"
#include "configure.hpp"
#include "constant.hpp"
#include "log.hpp"
#include "aka.hpp"
#include "age.hpp"
#include "scandir.hpp"
#include "attach.hpp"
#include "badmsg.hpp"
#include "passwd.hpp"
#include "nodelist.hpp"

extern int DetectError;
extern int NoTokensF;

extern FA   cffa;
extern FA   cffa1;
extern FA   cffa2;

static int brf = FALSE, arf = FALSE, renumberf = FALSE, unpackf = FALSE;
static ScanDir *wsd = NULL;
static char *FileName = NULL;
static tTimes *tt;
static IndBiList<tTimes> *_TTimes;
static MSGBASE *mbase;
static Mask *msk = NULL;
static int MaskMode;
static int rc;
static int FlagMode = 0;
static Action *act = NULL;

static void CheckETTime(void) {
time_t tmt;
   if (tt->_ETime != 0 && tt->_ETime < tt->_STime) {
      tmt = tt->_ETime;
      tt->_ETime = (23*60*60)+(59*60)+59;
      tt->_ETime += TimeOfBeginOfDay(-1);
      _TTimes->AddToEnd(tt);
      tt = new tTimes;
      tt->_STime = TimeOfBeginOfDay(-1);
      tt->_ETime = tmt;
   }
}

static int PrepareMask(Mask &m) {
ScanDir *sd;
char ErrMess[128];

   CHP = 23700;
   sd = ScanDirs.GetLast();
   if (sd == NULL) {
      strcpy(ErrMess,"'");
      strcat(ErrMess,m.MaskName());
      strcat(ErrMess,":' without 'ScanDir:'");
      yyerror(ErrMess);
      return -1;
   }
   m.sd = sd;
   return 0;
}

static void AddReadyMask(Mask &m) {
ScanDir *sd;

   switch (PrevMask) {
      case 0: // first mask.
      case 1: // after action.
         LastDo = new DoList();
         sd = ScanDirs.GetLast();
         sd->_DoLists.AddToEnd(LastDo);
         PrevMask = 2;
         break;
      case 2: // after MASK.
         break;
   }
   LastDo->AddMask(m);
}


static int CheckMaskMode(char *f) {
char Buff[128];
   if (MaskMode != 0) {
      strcpy(Buff,"You can use '");
      strcat(Buff,f);
      strcat(Buff,"' flag only in 'Mask:'.");
      yyerror(Buff);
      return -1;
   }
   return 0;
}


static int ctoi(char *s) {
   char *foo;
   int res = strtoul(s, &foo, 0);
   if (*foo)	/* parse error */
      return 0;
   return res;
}




typedef union {
   int          in;
   char         *ch;
   long         ln;
   KillModeT    kmode;
   CheckPointsT pmode;
   tBadMsgMode  bmode;
   time_t       t;
   PKTMode      pktmode;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		421
#define	YYFLAG		-32768
#define	YYNTBASE	136

#define YYTRANSLATE(x) ((unsigned)(x) <= 346 ? yytranslate[x] : 263)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   102,     2,   132,    99,   101,   134,     2,     2,
     2,   100,    93,     2,    94,    95,   135,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    98,     2,     2,
     2,     2,     2,   133,   104,     2,     2,     2,   109,     2,
     2,     2,     2,     2,     2,   117,     2,     2,     2,    97,
     2,     2,   124,     2,     2,     2,     2,     2,     2,     2,
   130,     2,   131,     2,     2,     2,   103,   105,   106,   107,
   108,   110,   111,   112,   113,   114,   115,   116,   118,   119,
   120,    96,   121,   122,   123,   125,   126,   127,     2,   128,
   129,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,    10,    13,    16,    19,    22,    25,
    28,    31,    34,    37,    40,    43,    46,    49,    52,    55,
    58,    61,    64,    67,    70,    73,    76,    79,    82,    85,
    88,    91,    94,    97,   100,   103,   106,   109,   112,   115,
   118,   121,   124,   127,   130,   133,   136,   139,   142,   145,
   148,   149,   153,   155,   158,   162,   165,   166,   167,   173,
   176,   179,   180,   184,   187,   189,   191,   193,   196,   198,
   200,   202,   205,   208,   211,   214,   217,   221,   222,   224,
   227,   230,   233,   236,   239,   242,   245,   248,   251,   254,
   255,   260,   263,   265,   267,   269,   272,   275,   277,   280,
   283,   284,   288,   291,   292,   297,   299,   301,   302,   305,
   307,   309,   311,   312,   316,   317,   321,   322,   325,   327,
   331,   335,   337,   339,   340,   345,   346,   349,   351,   355,
   356,   358,   359,   363,   364,   368,   369,   373,   374,   375,
   376,   377,   378,   379,   392,   394,   396,   398,   400,   402,
   404,   407,   409,   410,   412,   414,   415,   418,   420,   423,
   425,   426,   430,   431,   435,   437,   439,   441,   443,   445,
   447,   449,   451,   453,   455,   457,   459,   461,   463,   465,
   467,   469,   471,   473,   475,   477,   479,   481,   483,   485,
   487,   489,   491,   493,   496,   499,   502,   503,   508,   511,
   514,   517,   518,   523,   524,   525,   531,   532,   536,   538,
   540,   542,   544,   546,   548,   550,   552,   554,   556,   558,
   560,   562,   564,   566,   568,   570,   572,   574,   576,   578,
   581,   584,   587,   588,   592,   595,   597,   600,   603,   604,
   610,   614,   618,   623,   626,   627,   632,   634,   636,   638,
   640,   641,   646,   649,   652,   655,   658,   661,   663,   666,
   668,   670,   672,   674,   676,   678,   680,   684,   688,   690,
   692,   698,   700
};

static const short yyrhs[] = {    -1,
   136,   137,     0,   228,    51,     0,   141,    51,     0,   145,
    51,     0,   147,    51,     0,    31,    51,     0,   142,    51,
     0,   146,    51,     0,   223,    51,     0,   224,    51,     0,
   225,    51,     0,   149,    51,     0,    42,    51,     0,   168,
    51,     0,    11,    51,     0,   157,    51,     0,   161,    51,
     0,   151,    51,     0,   218,    51,     0,   219,    51,     0,
   220,    51,     0,   155,    51,     0,   156,    51,     0,   162,
    51,     0,   194,    51,     0,   196,    51,     0,   198,    51,
     0,   169,    51,     0,   163,    51,     0,   164,    51,     0,
   158,    51,     0,   160,    51,     0,    26,    51,     0,   165,
    51,     0,   170,    51,     0,    41,    51,     0,    28,    51,
     0,    48,    51,     0,   153,    51,     0,   154,    51,     0,
    43,    51,     0,    10,    51,     0,   174,    51,     0,   166,
    51,     0,   167,    51,     0,   172,    51,     0,   176,    51,
     0,   140,    51,     0,   139,    51,     0,     0,     1,    51,
   138,     0,    51,     0,    50,    57,     0,    45,    60,    57,
     0,    38,    57,     0,     0,     0,    27,   143,   257,   144,
   257,     0,    49,    57,     0,    39,    57,     0,     0,     8,
   148,   257,     0,    40,   150,     0,    66,     0,    67,     0,
    68,     0,    46,   152,     0,    69,     0,    66,     0,    65,
     0,     9,    57,     0,    37,    57,     0,     3,    57,     0,
     4,    60,     0,    36,    57,     0,     5,    57,   159,     0,
     0,    60,     0,     7,    57,     0,     6,    57,     0,    12,
    57,     0,    44,    60,     0,    47,    60,     0,    30,    57,
     0,    32,    57,     0,    33,    57,     0,    29,    57,     0,
    24,    60,     0,     0,    34,    57,   171,   257,     0,    25,
   173,     0,    52,     0,    54,     0,    53,     0,    55,    57,
     0,    35,   175,     0,    60,     0,    93,    60,     0,    94,
    60,     0,     0,    13,   177,   178,     0,   180,   193,     0,
     0,    57,   179,   181,   193,     0,    58,     0,    59,     0,
     0,   181,   182,     0,    61,     0,    62,     0,   183,     0,
     0,    63,   184,   186,     0,     0,    64,   185,   191,     0,
     0,   186,   187,     0,   189,     0,   189,    94,   189,     0,
   188,    95,   189,     0,    96,     0,    97,     0,     0,    60,
   190,    98,    60,     0,     0,   191,   192,     0,    60,     0,
    60,    94,    60,     0,     0,   240,     0,     0,    14,   195,
   200,     0,     0,    15,   197,   200,     0,     0,    16,   199,
   200,     0,     0,     0,     0,     0,     0,     0,   201,   207,
   202,   257,   203,   207,   204,   257,   205,   208,   206,   211,
     0,    57,     0,    99,     0,   100,     0,   101,     0,    57,
     0,   100,     0,   210,    60,     0,   100,     0,     0,   102,
     0,   100,     0,     0,   212,   213,     0,   214,     0,   213,
   214,     0,   217,     0,     0,    93,   215,   217,     0,     0,
    94,   216,   217,     0,   103,     0,   104,     0,   105,     0,
   106,     0,   107,     0,   108,     0,   109,     0,   110,     0,
   111,     0,   112,     0,   113,     0,   114,     0,   115,     0,
   116,     0,   117,     0,   118,     0,   119,     0,   120,     0,
    96,     0,   121,     0,   122,     0,   123,     0,   124,     0,
   125,     0,   126,     0,   127,     0,   128,     0,   129,     0,
    60,     0,    20,   221,     0,    21,   221,     0,    22,   221,
     0,     0,   222,   208,   208,   209,     0,    17,   226,     0,
    18,   226,     0,    19,   226,     0,     0,   227,   208,   209,
   209,     0,     0,     0,    23,   229,   232,   230,   231,     0,
     0,   130,   183,   131,     0,   233,     0,    53,     0,   234,
     0,   235,     0,   236,     0,    73,     0,   238,     0,   239,
     0,   241,     0,   242,     0,   244,     0,   245,     0,   246,
     0,   247,     0,   250,     0,    82,     0,   252,     0,   253,
     0,   254,     0,   255,     0,   256,     0,    70,    57,     0,
    55,    57,     0,    71,    57,     0,     0,    72,   237,   200,
     0,    74,    57,     0,   240,     0,    65,    57,     0,    75,
    57,     0,     0,    76,   243,    57,    57,   200,     0,    77,
    57,    57,     0,    78,    57,    57,     0,    79,    57,    57,
    57,     0,    79,    57,     0,     0,    80,   249,   248,   257,
     0,    88,     0,    89,     0,    90,     0,    91,     0,     0,
    81,   249,   251,   257,     0,    83,    57,     0,    84,    57,
     0,    85,    57,     0,    86,    60,     0,    87,    57,     0,
   258,     0,   102,   258,     0,   261,     0,   259,     0,   100,
     0,   132,     0,   133,     0,    99,     0,   101,     0,   101,
    95,    60,     0,   261,    95,   260,     0,   262,     0,   134,
     0,   262,    98,   262,   135,   262,     0,    60,     0,   100,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   162,   163,   167,   168,   173,   174,   175,   181,   182,   183,
   184,   185,   186,   187,   193,   194,   200,   201,   202,   203,
   204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
   214,   215,   216,   217,   223,   224,   225,   231,   237,   243,
   244,   245,   251,   257,   258,   259,   260,   261,   262,   263,
   264,   265,   267,   273,   280,   288,   291,   291,   292,   301,
   309,   317,   318,   326,   329,   330,   331,   334,   337,   338,
   339,   342,   350,   358,   366,   374,   382,   390,   391,   394,
   402,   410,   418,   426,   434,   442,   450,   458,   466,   475,
   484,   492,   500,   501,   502,   503,   506,   514,   515,   516,
   521,   534,   545,   546,   563,   566,   567,   570,   571,   574,
   583,   596,   606,   613,   619,   626,   634,   635,   645,   649,
   654,   675,   676,   679,   688,   700,   701,   709,   718,   730,
   731,   736,   736,   742,   742,   748,   748,   754,   762,   766,
   778,   782,   802,   806,   811,   812,   813,   814,   817,   818,
   821,   828,   831,   832,   835,   836,   837,   838,   839,   842,
   843,   844,   844,   845,   847,   848,   858,   859,   860,   861,
   867,   873,   874,   884,   885,   886,   887,   888,   889,   890,
   891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
   901,   907,   908,   923,   929,   935,   941,   949,   958,   964,
   970,   976,   984,   993,  1006,  1010,  1012,  1013,  1016,  1017,
  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1039,
  1052,  1073,  1094,  1098,  1103,  1109,  1115,  1118,  1124,  1128,
  1165,  1179,  1193,  1206,  1212,  1212,  1230,  1231,  1232,  1233,
  1236,  1236,  1250,  1260,  1274,  1284,  1294,  1346,  1347,  1350,
  1351,  1352,  1359,  1366,  1373,  1380,  1387,  1400,  1403,  1404,
  1407,  1416,  1417
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","_LOGFILE",
"_LOGLEVEL","_NODELIST","_INDEXFILE","_NODELISTPATH","_ADDRESS","_SYSOPNAME",
"_USEOWNZONE","_FORCEINTL","_LOOPSTR","_SCANDIR","_MASK","_SMASK","_PMASK","_BODYMASK",
"_SBODYMASK","_PBODYMASK","_KLUDGEMASK","_SKLUDGEMASK","_PKLUDGEMASK","_ACTION",
"_MAXAGE","_BADMESSAGES","_NOLOGIGNORE","_AKA","_SKIPHIDDENFILES","_FILEINBOUND",
"_OUTBOUND","_ADDTONULLPKT","_TEMPMAIL","_TRAFFICLOG","_PASSWORD","_UTC","_ORIGIN",
"_TEARLINE","_INCLUDE","_APKTDIR","_CHECKPOINTS","_SETVIAALWAYS","_CREATEMISSINGBASE",
"_USENEWVIA","_MAXATTACHSIZE","_SEMAPHORE","_KILLROUTEDMESSAGE","_MAXNODELISTAGE",
"_SOFTCHECKINNODELIST","_TIMESTAMPFILE","_TRAFFICLOGTEMPLATE","_CRLF","_SKIP",
"_DELETE","_EXIT","_MOVE","__EOF","_STRING","_BEFOREROUTE","_AFTERROUTE","_DIGIT_",
"_RENUMBER","_UNPACK","_DAILY","_WEEKLY","_FLAG","_NEVER","_HARD","_SOFT","_ALWAYS",
"_ADDNOTE","_COPY","_REWRITE","_IGNORE","_DISPLAY","_DELFILE","_NEWMSG","_WRITEFILE",
"_APPENDTOFILE","_CALL","_ROUTE","_POLL","_DELETEATTACH","_CHANGEPATH","_MOVEATTACH",
"_COPYATTACH","_SPLIT","_RECODE","_HOLD","_CRASH","_DIRECT","_NORMAL","LEXERR",
"'+'","'-'","'.'","'p'","'P'","':'","'$'","'*'","'%'","'!'","'a'","'A'","'b'",
"'c'","'d'","'e'","'E'","'f'","'g'","'h'","'i'","'j'","'k'","'l'","'L'","'m'",
"'n'","'o'","'q'","'r'","'s'","'S'","'t'","'u'","'v'","'x'","'y'","'['","']'",
"'#'","'@'","'&'","'/'","Conf","ConfLine","@1","TrafficLogTemplate","Semaphore",
"IncludeF","Aka","@2","@3","TimeStampFile","APktDir","Address","@4","CheckPoints",
"ChkPntMode","KillRoutedMessage","KillRMode","SysopName","TearLine","LogFile",
"LogLevel","Origin","Nodelist","NdlZone","NodelistPath","IndexFile","LoopStr",
"MaxAttachSize","MaxNodelistAge","Outbound","TempMail","TrafficLog","FileInbound",
"MaxAge","Password","@5","BadMessages","BadMsgMode","Utc","UtcOffs","ScanDir",
"@6","SDType","@7","BeforeAfter","AddSdParam","SdParam","STime","@8","@9","DaySTime",
"DaySSTime","AnyP","Time","@10","WeekSTime","WeekSSTime","Flag","Mask","@11",
"SMask","@12","PMask","@13","MParam","@14","@15","@16","@17","@18","@19","SyName",
"MString","MDigit","MNot","MsgAttr","@20","MsgFAttr","FlagsMode","@21","@22",
"FlagsChar","KludgeMask","SKludgeMask","PKludgeMask","KMParam","@23","BodyMask",
"SBodyMask","PBodyMask","BMParam","@24","Action","@25","@26","MayBeActTime",
"ActionCmd","AAddNote","AMove","ACopy","ARewrite","@27","ADisplay","AAFlag",
"AFlag","ADelFile","ANewMsg","@28","AWriteFile","AAppendToFile","ACall","ARoute",
"@29","RouMode","APoll","@30","AChangePath","AMoveAttach","ACopyAttach","ASplit",
"ARecode","faddress","FullFtnAddr","pointaddr","PntAddr","nodeaddr","dw", NULL
};
#endif

static const short yyr1[] = {     0,
   136,   136,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
   137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
   138,   137,   137,   139,   140,   141,   143,   144,   142,   145,
   146,   148,   147,   149,   150,   150,   150,   151,   152,   152,
   152,   153,   154,   155,   156,   157,   158,   159,   159,   160,
   161,   162,   163,   164,   165,   166,   167,   168,   169,   171,
   170,   172,   173,   173,   173,   173,   174,   175,   175,   175,
   177,   176,   178,   179,   178,   180,   180,   181,   181,   182,
   182,   182,   184,   183,   185,   183,   186,   186,   187,   187,
   187,   188,   188,   190,   189,   191,   191,   192,   192,   193,
   193,   195,   194,   197,   196,   199,   198,   201,   202,   203,
   204,   205,   206,   200,   207,   207,   207,   207,   208,   208,
   209,   209,   210,   210,   211,   212,   211,   213,   213,   214,
   215,   214,   216,   214,   217,   217,   217,   217,   217,   217,
   217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
   217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
   217,   217,   217,   218,   219,   220,   222,   221,   223,   224,
   225,   227,   226,   229,   230,   228,   231,   231,   232,   232,
   232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
   232,   232,   232,   232,   232,   232,   232,   232,   232,   233,
   234,   235,   237,   236,   238,   239,   240,   241,   243,   242,
   244,   245,   246,   246,   248,   247,   249,   249,   249,   249,
   251,   250,   252,   253,   254,   255,   256,   257,   257,   258,
   258,   258,   258,   258,   258,   258,   258,   259,   260,   260,
   261,   262,   262
};

static const short yyr2[] = {     0,
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     0,     3,     1,     2,     3,     2,     0,     0,     5,     2,
     2,     0,     3,     2,     1,     1,     1,     2,     1,     1,
     1,     2,     2,     2,     2,     2,     3,     0,     1,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
     4,     2,     1,     1,     1,     2,     2,     1,     2,     2,
     0,     3,     2,     0,     4,     1,     1,     0,     2,     1,
     1,     1,     0,     3,     0,     3,     0,     2,     1,     3,
     3,     1,     1,     0,     4,     0,     2,     1,     3,     0,
     1,     0,     3,     0,     3,     0,     3,     0,     0,     0,
     0,     0,     0,    12,     1,     1,     1,     1,     1,     1,
     2,     1,     0,     1,     1,     0,     2,     1,     2,     1,
     0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     2,     2,     0,     4,     2,     2,
     2,     0,     4,     0,     0,     5,     0,     3,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     2,     0,     3,     2,     1,     2,     2,     0,     5,
     3,     3,     4,     2,     0,     4,     1,     1,     1,     1,
     0,     4,     2,     2,     2,     2,     2,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
     5,     1,     1
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,     0,     0,     0,    62,     0,     0,
     0,     0,   101,   132,   134,   136,   202,   202,   202,   197,
   197,   197,   204,     0,     0,     0,    57,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    53,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    51,    74,    75,    78,    81,    80,     0,    72,    43,
    16,    82,     0,   138,   138,   138,   199,     0,   200,   201,
   194,     0,   195,   196,     0,    89,    93,    95,    94,     0,
    92,    34,     0,    38,    88,    85,     7,    86,    87,    90,
    98,     0,     0,    97,    76,    73,    56,    61,    65,    66,
    67,    64,    37,    14,    42,    83,     0,    71,    70,    69,
    68,    84,    39,    60,    54,    50,    49,     4,     8,     5,
     9,     6,    13,    19,    40,    41,    23,    24,    17,    32,
    33,    18,    25,    30,    31,    35,    45,    46,    15,    29,
    36,    47,    44,    48,    26,    27,    28,    20,    21,    22,
    10,    11,    12,     3,    52,    79,    77,   272,   265,   262,
   266,     0,   263,   264,    63,   258,   261,   260,     0,   104,
   106,   107,   102,   130,   133,     0,   135,   137,   149,   150,
   153,     0,   210,     0,     0,     0,     0,   233,   214,     0,
     0,   239,     0,     0,     0,     0,     0,   224,     0,     0,
     0,     0,     0,   205,   209,   211,   212,   213,   215,   216,
   236,   217,   218,   219,   220,   221,   222,   223,   225,   226,
   227,   228,   229,    96,    58,     0,    99,   100,    55,     0,
   259,     0,     0,   108,   103,   131,   145,   146,   147,   148,
   139,   152,   154,   153,     0,   153,   231,   237,   230,   232,
   138,   235,   238,     0,     0,     0,   244,   247,   248,   249,
   250,   245,   251,   253,   254,   255,   256,   257,   207,     0,
    91,   267,   273,   270,   268,   269,     0,   130,     0,   203,
   151,   198,   234,     0,   241,   242,     0,     0,     0,     0,
   206,    59,     0,   110,   111,   113,   115,   109,   112,   105,
   140,   138,   243,   246,   252,     0,   271,   117,   126,     0,
   240,   208,   114,   116,   141,   124,   122,   123,   118,     0,
   119,   128,   127,     0,     0,     0,     0,     0,   142,     0,
   121,   120,   129,     0,   125,   143,   156,   155,   144,     0,
   193,   161,   163,   183,   165,   166,   167,   168,   169,   170,
   171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
   181,   182,   184,   185,   186,   187,   188,   189,   190,   191,
   192,   157,   158,   160,     0,     0,   159,   162,   164,     0,
     0
};

static const short yydefgoto[] = {     1,
    52,   195,    53,    54,    55,    56,   123,   310,    57,    58,
    59,    98,    60,   142,    61,   151,    62,    63,    64,    65,
    66,    67,   197,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,   266,    79,   121,    80,   134,    81,
   103,   213,   274,   214,   318,   338,   339,   348,   349,   353,
   359,   360,   361,   365,   354,   363,   275,    82,   104,    83,
   105,    84,   106,   215,   216,   319,   350,   364,   374,   377,
   281,   221,   284,   285,   379,   380,   412,   413,   415,   416,
   414,    85,    86,    87,   111,   112,    88,    89,    90,   107,
   108,    91,   115,   309,   331,   244,   245,   246,   247,   248,
   291,   249,   250,   276,   252,   253,   294,   254,   255,   256,
   257,   328,   302,   258,   329,   259,   260,   261,   262,   263,
   205,   206,   207,   315,   208,   209
};

static const short yypact[] = {-32768,
   260,   -37,   -46,   -42,   -14,     4,    18,-32768,    22,   -25,
    29,    26,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    24,   -31,    34,-32768,    35,    30,    31,
    38,    33,    36,    37,   -35,    39,    40,    41,    42,   -30,
    44,    49,    54,    32,    46,   -53,    47,    57,    52,    81,
-32768,-32768,    89,    90,    91,    92,    94,   122,   123,   124,
   125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
   135,   136,   139,   141,   143,   144,   145,   147,   148,   149,
   150,   151,   153,   154,   175,   176,   177,   178,   179,   180,
   181,-32768,-32768,-32768,   173,-32768,-32768,   -55,-32768,-32768,
-32768,-32768,   -18,-32768,-32768,-32768,-32768,   -49,-32768,-32768,
-32768,   -49,-32768,-32768,   138,-32768,-32768,-32768,-32768,   182,
-32768,-32768,   -55,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   174,   183,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   184,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -7,
   140,   -51,-32768,-32768,-32768,-32768,-32768,   142,   146,-32768,
-32768,-32768,-32768,   171,-32768,   -47,-32768,-32768,-32768,-32768,
   -83,   -49,-32768,   188,   189,   190,   191,-32768,-32768,   192,
   193,-32768,   194,   195,   196,   -56,   -56,-32768,   197,   198,
   199,   252,   200,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -55,-32768,-32768,-32768,   253,
-32768,   -58,   -45,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   -83,   254,   -83,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   201,   202,   258,   259,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   108,   -55,
-32768,-32768,-32768,-32768,-32768,-32768,   185,   -34,   -55,-32768,
-32768,-32768,-32768,   261,-32768,-32768,   262,   -55,   -55,     0,
-32768,-32768,   -45,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   186,-32768,-32768,-32768,   -47,
-32768,-32768,   -40,   263,-32768,-32768,-32768,-32768,-32768,   226,
   228,   230,-32768,   -55,   227,   266,   266,   267,-32768,   268,
-32768,-32768,-32768,   -49,-32768,-32768,   229,-32768,-32768,     8,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,     8,-32768,-32768,    43,    43,-32768,-32768,-32768,   330,
-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,     1,-32768,-32768,-32768,
-32768,-32768,  -301,-32768,-32768,-32768,    14,-32768,-32768,-32768,
-32768,-32768,-32768,  -102,-32768,-32768,-32768,-32768,-32768,-32768,
   -17,  -112,  -224,-32768,-32768,-32768,-32768,   -78,-32768,-32768,
  -346,-32768,-32768,-32768,    50,-32768,-32768,-32768,-32768,    55,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   220,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    99,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -122,   137,-32768,-32768,-32768,  -266
};


#define	YYLAST		339


static const short yytable[] = {   222,
   265,   198,   217,   218,   198,   316,   317,   219,   198,   277,
    93,   148,   149,    92,   198,   150,   282,    94,   283,   356,
   117,   118,   119,   120,   131,   100,   334,   335,   336,   337,
   225,   298,   299,   300,   301,   139,   140,   141,   210,   211,
   212,   313,    95,   199,   200,   201,   202,   199,   200,   201,
   220,   278,   279,   280,   313,   357,   358,   132,   133,   320,
    96,   322,   336,   337,   371,   372,   347,   381,   418,   419,
   113,   114,   109,   110,    97,   314,   203,   204,    99,   101,
   203,   204,   102,   116,   122,   124,   125,   126,   127,   128,
  -273,   146,   129,   130,   143,   135,   136,   137,   138,   144,
   382,   383,   381,   384,   145,   147,   152,   153,   154,   286,
   385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
   395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
   405,   406,   407,   408,   409,   410,   411,   155,   384,   156,
   157,   158,   159,   311,   160,   385,   386,   387,   388,   389,
   390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
   400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
   410,   411,   161,   162,   163,   164,   165,   166,   167,   168,
   169,   170,   171,   172,   173,   174,   175,   332,   323,   176,
   223,   177,   224,   178,   179,   180,   341,   181,   182,   183,
   184,   185,   225,   186,   187,   344,   345,   226,   227,   228,
   229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
   239,   240,   241,   242,   243,   188,   189,   190,   191,   192,
   193,   194,   196,   267,   270,   225,   272,   330,   264,   351,
   269,   369,   268,   273,   287,   288,   289,   290,   292,   293,
   295,   296,   297,   304,   305,   306,   308,   324,   325,   420,
     2,   376,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,   307,   312,   321,   326,   327,   352,   342,   343,   333,
   366,   367,   362,   368,   370,   356,   373,   375,   378,   421,
   346,   340,   355,   417,   251,   303,     0,     0,   271
};

static const short yycheck[] = {   112,
   123,    60,   105,   106,    60,   272,   273,    57,    60,    57,
    57,    65,    66,    51,    60,    69,   100,    60,   102,    60,
    52,    53,    54,    55,    60,    51,    61,    62,    63,    64,
    65,    88,    89,    90,    91,    66,    67,    68,    57,    58,
    59,   100,    57,    99,   100,   101,   102,    99,   100,   101,
   100,    99,   100,   101,   100,    96,    97,    93,    94,   284,
    57,   286,    63,    64,   366,   367,   333,    60,   415,   416,
    21,    22,    18,    19,    57,   134,   132,   133,    57,    51,
   132,   133,    57,    60,    51,    51,    57,    57,    51,    57,
    98,    60,    57,    57,    51,    57,    57,    57,    57,    51,
    93,    94,    60,    96,    51,    60,    60,    51,    57,   222,
   103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
   113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   126,   127,   128,   129,    57,    96,    51,
    51,    51,    51,   266,    51,   103,   104,   105,   106,   107,
   108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
   128,   129,    51,    51,    51,    51,    51,    51,    51,    51,
    51,    51,    51,    51,    51,    51,    51,   310,   291,    51,
    53,    51,    55,    51,    51,    51,   319,    51,    51,    51,
    51,    51,    65,    51,    51,   328,   329,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    51,    51,    51,    51,    51,
    51,    51,    60,    60,    95,    65,    95,   130,    57,   342,
    57,   364,    60,    98,    57,    57,    57,    57,    57,    57,
    57,    57,    57,    57,    57,    57,    57,    57,    57,     0,
     1,   374,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    60,    60,    60,    57,    57,   131,    57,    57,   135,
    95,    94,    60,    94,    98,    60,    60,    60,   100,     0,
   330,   318,   350,   412,   115,   237,    -1,    -1,   202
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
{
            if (SetInclude(yyvsp[-1].ch) != 0) {
               YYABORT;
            }
         ;
    break;}
case 7:
{
               if (SetAddToNullPkt() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 14:
{
               if (SetCreateMissingBase() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 16:
{
               if (SetForceINTL() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 34:
{
               if (SetNoLogIgnore() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 37:
{
               if (SetSetViaAlways() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 38:
{
               if (SetSkipHiddenFiles() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 39:
{
               if (SetSoftCheckInNodelists() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 42:
{
               if (SetNewVia() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 43:
{
               if (SetUseOwnZone() != 0) {
                  YYABORT;
               }
            ;
    break;}
case 51:
{ YYABORT; ;
    break;}
case 52:
{ DetectError = TRUE;
         ;
    break;}
case 53:
{
            avail = 0;
         ;
    break;}
case 54:
{
                      if (SetTrafficLogTemplate(yyvsp[0].ch) != 0) {
                         YYABORT;
                      }
                   ;
    break;}
case 55:
{
             if (SetSemaphoreName(yyvsp[0].ch, yyvsp[-1].ln) != 0) {
                YYABORT;
             }
          ;
    break;}
case 56:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 57:
{ cffa.Clean(); ;
    break;}
case 58:
{ cffa1 = cffa; cffa.Clean(); ;
    break;}
case 59:
{
               if (SetAka(cffa1, cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
               cffa1.Clean();
            ;
    break;}
case 60:
{
               if (SetTimeStampFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 61:
{
               if (SetAPktDir(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 62:
{ cffa.Clean(); ;
    break;}
case 63:
{
               if (SetMyAddr(cffa) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 64:
{ SetCheckPoints(yyvsp[0].pmode); ;
    break;}
case 65:
{ yyval.pmode = CHECKPNT_NEVER; ;
    break;}
case 66:
{ yyval.pmode = CHECKPNT_HARD; ;
    break;}
case 67:
{ yyval.pmode = CHECKPNT_SOFT; ;
    break;}
case 68:
{ SetKillRoutedMessages(yyvsp[0].kmode); ;
    break;}
case 69:
{ yyval.kmode = KILL_ALWAYS; ;
    break;}
case 70:
{ yyval.kmode = KILL_NEVER; ;
    break;}
case 71:
{ yyval.kmode = KILL_FLAG; ;
    break;}
case 72:
{
               if (SetSysopName(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 73:
{
               if (SetTearline(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 74:
{
               if (SetLogFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 75:
{
               if (SetLogLevel(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 76:
{
               if (SetOrigin(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 77:
{
               if (SetNodelist(yyvsp[-1].ch,yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 78:
{ yyval.ln = -3; ;
    break;}
case 79:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 80:
{
               if (SetNodelistPath(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 81:
{
               if (SetIndexFile(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 82:
{
               if (SetLoopStr(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 83:
{
               if (SetMaxAttach(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 84:
{
               if (SetMaxNodelistAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 85:
{
               if (SetOutbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 86:
{
               if (SetTempMail(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 87:
{
               if (SetTrafficLog(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 88:
{
               if (SetFileInbound(yyvsp[0].ch) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 89:
{
               if (SetMaxAge(yyvsp[0].ln) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 90:
{
               if (strlen(yyvsp[0].ch) > 8){
                  yyerror("Password too long. Max password length is a 8 characters.");
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 91:
{
               if (SetPasswd(cffa, yyvsp[-2].ch) != 0) {
                  YYABORT;
               }
               cffa.Clean();
            ;
    break;}
case 92:
{ 
                if (SetBadMode(yyvsp[0].bmode,FileName) != 0) {
                  YYABORT;
                }
                FileName = NULL;
              ;
    break;}
case 93:
{ yyval.bmode = SKIP; FileName = NULL;;
    break;}
case 94:
{ yyval.bmode = EXIT; FileName = NULL;;
    break;}
case 95:
{ yyval.bmode = REMOVE; FileName = NULL;;
    break;}
case 96:
{ yyval.bmode = MOVE; FileName = yyvsp[0].ch;;
    break;}
case 97:
{ 
                if (SetUTC(yyvsp[0].ln) != 0) {
                  YYABORT;
                }
              ;
    break;}
case 98:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 99:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 100:
{ yyval.ln = -yyvsp[0].ln; ;
    break;}
case 101:
{ 
              wsd = new ScanDir(); 
              CheckMem((char *)wsd); 
              renumberf = FALSE;
              unpackf = FALSE;
              arf = FALSE;
              brf = FALSE;
              _TTimes = &wsd->_Times;
              mbase = NULL;
              PrevMask = 0;
           ;
    break;}
case 102:
{
              wsd->SetBase(mbase);
              wsd->_Renumber = renumberf;
              wsd->_Unpack = unpackf;
              wsd->_FlagFile = FileName;
              ScanDirs.AddToEnd(wsd);
              if (brf) BeforeRoute = wsd;
              if (arf) AfterRoute = wsd;
           ;
    break;}
case 104:
{
             mbase = MakeBase(yyvsp[0].ch);
             if (mbase == NULL) {
                YYABORT;
             }
             if (!mbase->Set(yyvsp[0].ch,BASE_IN)) {
                delete mbase;
                mbase = NULL;
                yyerror("Unable to open message base.");
                YYABORT;
             }
             if (!mbase->CheckIn()) {
                delete mbase;
                YYABORT;
             }
          ;
    break;}
case 106:
{ brf = TRUE; ;
    break;}
case 107:
{ arf = TRUE; ;
    break;}
case 110:
{
                  if (renumberf == TRUE) {
                     yyerror("Renumber for this base already set.");
                     YYABORT;
                  } else {
                    renumberf = TRUE;
                  }
               ;
    break;}
case 111:
{
                  if (unpackf == TRUE) {
                     yyerror("Unpack for this base already set.");
                     YYABORT;
                  } else {
                     unpackf = TRUE;
                  }
                  if (Outbound == NULL) {
                     yyerror("Outbound directory not specified.");
                     YYABORT;
                  }
               ;
    break;}
case 112:
{
                  if (TimeStampFile == NULL) {
                     yyerror("You can't set scanning time without Timestamp File.");
                     YYABORT;
                  }

               ;
    break;}
case 113:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(-1);
                  tt->_ETime = 0;
               ;
    break;}
case 114:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 115:
{
                  tt = new tTimes;
                  tt->_STime = TimeOfBeginOfDay(0);
                  tt->_ETime = 0;
               ;
    break;}
case 116:
{
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                  }
               ;
    break;}
case 118:
{ 
                  if (tt->_STime != 0) {
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                  }
               ;
    break;}
case 119:
{ 
                  tt->_STime = yyvsp[0].t + TimeOfBeginOfDay(-1); 
               ;
    break;}
case 120:
{ 
                  tt->_STime = yyvsp[-2].t + TimeOfBeginOfDay(-1); 
                  tt->_ETime = yyvsp[0].t + TimeOfBeginOfDay(-1) + 59; 
               ;
    break;}
case 121:
{
                  time_t i_time;
                  time_t b_time;
                  if (yyvsp[0].t == (time_t) 0) {
                     yyerror("Time of pereodical event should be between 00:01 and 23:59");
                     YYABORT;
                  }
                  tt->_STime = TimeOfBeginOfDay(-1);
                  b_time = tt->_STime; 
                  do {
                     i_time = tt->_STime; 
                     CheckETTime();
                     _TTimes->AddToEnd(tt);
                     tt = new tTimes;
                     tt->_ETime = 0;
                     tt->_STime = i_time + yyvsp[0].t;
                  } while (tt->_STime < (b_time + (23*60*60)+(59*60)+60));
                  tt->_STime = 0;
            ;
    break;}
case 124:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 23) {
                    yyerror("Hour should be between 00 and 23");
                    YYABORT;
                 } else {
                    yyval.t = (time_t) (yyvsp[0].ln * 60);
                 }
              ;
    break;}
case 125:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 59 || yyvsp[-2].t == (time_t) -1) {
                    yyval.t = (time_t)-1;
                    yyerror("Minutes should be between 00 and 59");
                    YYABORT;
                 } else {
                    yyval.t = yyvsp[-2].t + (time_t) yyvsp[0].ln;
                    yyval.t *= 60;
                 }
              ;
    break;}
case 127:
{ 
                  CheckETTime();
                  _TTimes->AddToEnd(tt);
                  tt = new tTimes;
               ;
    break;}
case 128:
{ 
                 if (yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[0].ln); 
                 }
              ;
    break;}
case 129:
{ 
                 if (yyvsp[-2].ln < 0 || yyvsp[-2].ln > 6 || yyvsp[0].ln < 0 || yyvsp[0].ln > 6) {
                    yyerror("Day of week should be between 0 and 6");
                    YYABORT;
                 } else {
                    tt->_STime = TimeOfBeginOfDay(yyvsp[-2].ln); 
                    tt->_ETime = TimeOfBeginOfDay(yyvsp[0].ln) + (23*60*60)+(59*60)+59; 
                 }
              ;
    break;}
case 130:
{ FileName = NULL; ;
    break;}
case 131:
{ FileName = strdup(yyvsp[0].ch); ;
    break;}
case 132:
{ MaskMode = 0; ;
    break;}
case 133:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 134:
{ MaskMode = 0; ;
    break;}
case 135:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 136:
{ MaskMode = 0; ;
    break;}
case 137:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(NormalMask *)msk);
            ;
    break;}
case 138:
{ 
               msk = new NormalMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 139:
{
               ((NormalMask *)msk)->_FromName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 140:
{
               ((NormalMask *)msk)->_FromAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_FromAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_FromAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'From' Address.");
                  YYABORT;
               }
            ;
    break;}
case 141:
{
               ((NormalMask *)msk)->_ToName = strdup(yyvsp[0].ch);
               cffa.Clean();
            ;
    break;}
case 142:
{
               ((NormalMask *)msk)->_ToAddr = cffa;
               if (MaskMode == 0) {
                  rc = ((NormalMask *)msk)->_ToAddr.MaskValid(); 
               } else {
                  rc = ((NormalMask *)msk)->_ToAddr.ActValid(); 
               }
               if (!rc) {
                  yyerror("Invalid 'To' Address.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Zone() & FA_LSTMASK) && (!Ndl.Enabled())) {
                  yyerror("You can't use '#' mask without nodelist.");
                  YYABORT;
               }
               if ((((NormalMask *)msk)->_ToAddr.Point() & FA_SUBMASK) && (!Ndl.Enabled())) {
                  yyerror("You can't use '&' mask without nodelist.");
                  YYABORT;
               }
            ;
    break;}
case 143:
{ 
               ((NormalMask *)msk)->_Subject = strdup(yyvsp[0].ch);
               NoTokensF = TRUE; 
            ;
    break;}
case 144:
{ 
               NoTokensF = FALSE; 
            ;
    break;}
case 146:
{ yyval.ch = "$"; ;
    break;}
case 147:
{ yyval.ch = "*"; ;
    break;}
case 148:
{ yyval.ch = "%"; ;
    break;}
case 150:
{ yyval.ch = "*"; ;
    break;}
case 151:
{
               if (yyvsp[0].ln > 65535) {
                  yyerror("Parameter shoul be less that 65535");
                  YYABORT;
               }
               yyval.ln = yyvsp[-1].ln | yyvsp[0].ln;
            ;
    break;}
case 152:
{ yyval.ln = -1; ;
    break;}
case 153:
{ yyval.ln = 0; ;
    break;}
case 154:
{ yyval.ln = 0x08000000; ;
    break;}
case 156:
{ FlagMode = 1; ;
    break;}
case 161:
{ FlagMode = 1; ;
    break;}
case 163:
{ FlagMode = 2; ;
    break;}
case 165:
{ ((NormalMask *)msk)->fFileAttach = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 166:
{ /* CheckMaxAttach size*/
               if (CheckMaskMode("A") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAttachSize == 0 && MaxAttachSize == 0) {
                  yyerror("Not one (global or local) MaxAttachSize is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAttach = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 167:
{ ((NormalMask *)msk)->fARQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 168:
{ ((NormalMask *)msk)->fCrash = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 169:
{ ((NormalMask *)msk)->fDIR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 170:
{ /* Empty message */
               if (CheckMaskMode("e") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEmpty = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 171:
{ /* Check echomail */
               if (CheckMaskMode("E") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fEchomail = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 172:
{ ((NormalMask *)msk)->fFileRequest = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 173:
{ /* Check age */
               if (CheckMaskMode("g") != 0) {
                  YYABORT;
               }
               if (((NormalMask *)msk)->sd->_MaxAge == 0 && MaxAge == 0) {
                  yyerror("Not one (global or local) MaxAge is not defined.");
                  YYABORT;
               }
               ((NormalMask *)msk)->fMaxAge = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 174:
{ ((NormalMask *)msk)->fHold = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 175:
{ ((NormalMask *)msk)->fTransit = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 176:
{ ((NormalMask *)msk)->fKFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 177:
{ ((NormalMask *)msk)->fKillSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 178:
{ ((NormalMask *)msk)->fLocal = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 179:
{ ((NormalMask *)msk)->fLok = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 180:
{ ((NormalMask *)msk)->fIMM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 181:
{ ((NormalMask *)msk)->fCFM = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 182:
{ ((NormalMask *)msk)->fOrphan = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 183:
{ ((NormalMask *)msk)->fPrivate = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 184:
{ ((NormalMask *)msk)->fRRQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 185:
{ ((NormalMask *)msk)->fReceived = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 186:
{ ((NormalMask *)msk)->fSend = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 187:
{ ((NormalMask *)msk)->fAS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 188:
{ ((NormalMask *)msk)->fTFS = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 189:
{ ((NormalMask *)msk)->fFURQ = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 190:
{ ((NormalMask *)msk)->fScanned = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 191:
{ /* Check existing attach */
               if (CheckMaskMode("x") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fAttExists = (FlagMode == 2) ? 2 : 1;
            ;
    break;}
case 192:
{ ((NormalMask *)msk)->fIRR = (FlagMode == 2) ? 2 : 1; ;
    break;}
case 193:
{
               if (CheckMaskMode("loop flag") != 0) {
                  YYABORT;
               }
               ((NormalMask *)msk)->fLoop = (FlagMode == 2) ? 2 : 1;
               if (((NormalMask *)msk)->Loops != (unsigned int)-1) {
                  yyerror("Only one loop count should be in mask.");
                  YYABORT;
               }
               ((NormalMask *)msk)->Loops = yyvsp[0].ln;
            ;
    break;}
case 194:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 195:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 196:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(KludgeMask *)msk);
            ;
    break;}
case 197:
{ 
               msk = new KludgeMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 198:
{
               ((KludgeMask *)msk)-> _KludgeName = strdup(yyvsp[-2].ch);
               ((KludgeMask *)msk)-> _KludgeBody = strdup(yyvsp[-1].ch);
               ((KludgeMask *)msk)-> _Times = yyvsp[0].ln;
            ;
    break;}
case 199:
{ 
               msk->_Type = MASK_NORMAL;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 200:
{ 
               msk->_Type = MASK_SKIP;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 201:
{ 
               msk->_Type = MASK_ADD;
               AddReadyMask(*(BodyMask *)msk);
            ;
    break;}
case 202:
{ 
               msk = new BodyMask();
               CheckMem((char *)msk);
               msk->_Type = MASK_NORMAL;
               if (PrepareMask(*msk) != 0) {
                  YYABORT;
               }
            ;
    break;}
case 203:
{
               ((BodyMask *)msk)-> _Body = strdup(yyvsp[-2].ch);
               ((BodyMask *)msk)-> _Lines = yyvsp[-1].ln;
               ((BodyMask *)msk)-> _Bytes = yyvsp[0].ln;
            ;
    break;}
case 204:
{
          if (PrevMask == 0) {
             yyerror("Action without Mask.");
             YYABORT;
          }
          wsd = ScanDirs.GetLast();
          PrevMask = 1;
          act = new Action();
          act->sd = wsd;
          act->Before = BeforeRoute;
          act->After = AfterRoute;
         _TTimes = &act->_Times;       
       ;
    break;}
case 205:
{
          LastDo->AddAction(*act);
       ;
    break;}
case 210:
{ act->_Act = ACT_DELETE; ;
    break;}
case 214:
{ act->_Act = ACT_IGNORE; ;
    break;}
case 224:
{ act->_Act = ACT_DELETEATTACH; ;
    break;}
case 230:
{
            act->_Act = ACT_ADDNOTE;
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[0].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               YYABORT;
            }
            act->_Tpl->sd = ScanDirs.GetLast();
         ;
    break;}
case 231:
{
            act->_Act = ACT_MOVE;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 232:
{
            act->_Act = ACT_COPY;
            act->_Base = MakeBase(yyvsp[0].ch);
            if (act->_Base == NULL) {
               YYABORT;
            }
            if (!act->_Base->Set(yyvsp[0].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
         ;
    break;}
case 233:
{
              MaskMode = 1;
              act->_Act = ACT_REWRITE;
           ;
    break;}
case 234:
{
              act->_Mask = msk;
           ;
    break;}
case 235:
{ 
            act->_Act = ACT_DISPLAY; 
            act->_TplName = strdup(yyvsp[0].ch);
         ;
    break;}
case 236:
{
            act->_Act = ACT_FLAG; 
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 237:
{ yyval.ch = yyvsp[0].ch; ;
    break;}
case 238:
{
            act->_Act = ACT_DELFILE;
            act->_OutDir = strdup(yyvsp[0].ch);
         ;
    break;}
case 239:
{
            MaskMode = 1;
            act->_Act = ACT_NEWMSG;
         ;
    break;}
case 240:
{
            act->_Tpl = new Template();
            if (!act->_Tpl->Set(yyvsp[-2].ch)) {
               yyerror("Template file is not accesible.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               YYABORT;
            }
            act->_Tpl->sd =  ScanDirs.GetLast();
            act->_Base = MakeBase(yyvsp[-1].ch);
            if (act->_Base == NULL || !act->_Base->Set(yyvsp[-1].ch,BASE_OUT)) {
               yyerror("Invalid message base name.");
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            if (!act->_Base->CheckOut()) {
               delete act->_Tpl;
               act->_Tpl = NULL;
               delete msk;
               msk = NULL;
               delete act->_Base;
               act->_Base = NULL;
               YYABORT;
            }
            act->_Base->Rewind();
            act->_Mask = msk;

         ;
    break;}
case 241:
{
              act->_Act = ACT_WRITEFILE;
              act->_Tpl = new Template();
              if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                 yyerror("Template file is not accesible.");
                 delete act->_Tpl;
                 act->_Tpl = NULL;
                 YYABORT;
              }
              act->_Tpl->sd =  ScanDirs.GetLast();
              act->_OutDir = strdup(yyvsp[0].ch);
           ;
    break;}
case 242:
{
                   act->_Act = ACT_ADDFILE;
                   act->_Tpl = new Template();
                   if (!act->_Tpl->Set(yyvsp[-1].ch)) {
                      yyerror("Template file is not accesible.");
                      delete act->_Tpl;
                      act->_Tpl = NULL;
                      YYABORT;
                   }
                   act->_Tpl->sd =  ScanDirs.GetLast();
                   act->_OutDir = strdup(yyvsp[0].ch);
              ;
    break;}
case 243:
{
           act->_Act = ACT_CALL;
           act->_Tpl = new Template();
           if (!act->_Tpl->Set(yyvsp[-2].ch)) {
              yyerror("Template file is not accesible.");
              delete act->_Tpl;
              act->_Tpl = NULL;
              YYABORT;
           }
           act->_Tpl->sd =  ScanDirs.GetLast();
           act->_OutDir = strdup(yyvsp[-1].ch);
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 244:
{
           act->_Act = ACT_CALL;
           act->_TplName = strdup(yyvsp[0].ch);
      ;
    break;}
case 245:
{ cffa.Clean(); ;
    break;}
case 246:
{
          act->_Act = ACT_ROUTE;
          if (act->sd == act->Before|| act->sd == act->After) {
             yyerror("You can not use the Action Route in 'ScanDir: @AfterRoute|@BeforeRoute'");
             YYABORT;
          }
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid routing address.");
             YYABORT;
          }
       ;
    break;}
case 247:
{ yyval.pktmode = F_HOLD; ;
    break;}
case 248:
{ yyval.pktmode = F_CRASH; ;
    break;}
case 249:
{ yyval.pktmode = F_DIRECT; ;
    break;}
case 250:
{ yyval.pktmode = F_NORMAL; ;
    break;}
case 251:
{ cffa.Clean(); ;
    break;}
case 252:
{
          act->_Act = ACT_POLL;
          act->_Flav = yyvsp[-2].pktmode;
          act->_f = cffa;
          if (act->_f.Point() & FA_NOTDEF) {
             act->_f.Point(0);
          }
          if (!act->_f.RouValid()) {
             yyerror("Invalid poll address.");
             YYABORT;
          }
       ;
    break;}
case 253:
{
               act->_Act = ACT_CHANGEPATH;
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 254:
{
               act->_Act = ACT_MOVEATTACH;
               if (!DirExists(yyvsp[0].ch)) {
                  yyerror("Target directory not found.");
                  YYABORT;
               }
               if (strlen(yyvsp[0].ch) > 72) {
                  yyerror("New path too long");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 255:
{
               act->_Act = ACT_COPYATTACH;
               if (!DirExists(yyvsp[0].ch)) {
                  yyerror("Target directory not found.");
                  YYABORT;
               }
               act->_OutDir = strdup(yyvsp[0].ch);
            ;
    break;}
case 256:
{
               act->_Act = ACT_SPLIT;
               if (yyvsp[0].ln < 1 || yyvsp[0].ln > 65535) {
                  yyerror("Parameter 'Lines' should be positive integer between 1 and 65535");
                  YYABORT;
               }
               act->_Lines = yyvsp[0].ln;
            ;
    break;}
case 257:
{
               FILE *fp;
               char buf[512],*p,*q;
               int in,on,count;
               int line;

                  act->_Act = ACT_RECODE;
                  fp = fopen(yyvsp[0].ch,"r");
                  if (fp == NULL) {
                     yyerror("Unable to open file");
                     YYABORT;
                  }
                  act->_TplName = (char *)malloc(256);
                  CheckMem(act->_TplName);
                  for (count = 0; count < 256; count++) act->_TplName[count] = (char) count;
                  count = 0;	 
                  line = 0;

                  while (fgets((char*)buf,sizeof(buf),fp)) {
                     line++;
                     p = strtok((char*)buf," \t\n#");
                     q = strtok(NULL," \t\n#");
                     if (p != NULL && q != NULL) {
                        in = ctoi((char *)p);
                        if (in > 255) {
                           sprintf(buf, "%s: Error in line %d.", yyvsp[0].ch, line);
                           yyerror(buf);
                           fclose(fp);
                           free(act->_TplName);
                           YYABORT;
                        }
                        on=ctoi((char *)q);
                        if (in != 0 && on != 0) {
                           if (count++ < 256 ) {
                              act->_TplName[in]=on; 
                           } else { 
                              sprintf(buf,"Char map table \"%s\" is big",yyvsp[0].ch); 
                              yyerror(buf);
                              fclose(fp);
                              free(act->_TplName);
                              YYABORT;
                           }
                        }
                     } /* if */
                  } /* While */
                  fclose(fp);
            ;
    break;}
case 259:
{ cffa.Zone(cffa.Zone() | FA_NOTMASK); ;
    break;}
case 262:
{
                  cffa.Zone(FA_ANYMASK);
                  cffa.Net(FA_ANYMASK);
                  cffa.Node(FA_ANYMASK);
                  cffa.Point(FA_ANYMASK);
               ;
    break;}
case 263:
{
                  cffa.Zone(FA_LSTMASK);
                  cffa.Net(FA_LSTMASK);
                  cffa.Node(FA_LSTMASK);
                  cffa.Point(FA_LSTMASK);
               ;
    break;}
case 264:
{
                  cffa.Zone(FA_OURMASK);
                  cffa.Net(FA_OURMASK);
                  cffa.Node(FA_OURMASK);
                  cffa.Point(FA_OURMASK);
               ;
    break;}
case 265:
{
                  cffa.Zone(FA_FROMMASK);
                  cffa.Net(FA_FROMMASK);
                  cffa.Node(FA_FROMMASK);
                  cffa.Point(FA_FROMMASK);
               ;
    break;}
case 266:
{
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(FA_TOMASK);
               ;
    break;}
case 267:
{
                  if (yyvsp[0].ln != 0) {
                     yyerror("parse error");
                     YYABORT;
                  }
                  cffa.Zone(FA_TOMASK);
                  cffa.Net(FA_TOMASK);
                  cffa.Node(FA_TOMASK);
                  cffa.Point(0);
               ;
    break;}
case 269:
{ cffa.Point(yyvsp[0].ln); ;
    break;}
case 270:
{ cffa.Point(FA_SUBMASK); ;
    break;}
case 271:
{ 
               cffa.Zone(yyvsp[-4].ln); 
               cffa.Net(yyvsp[-2].ln); 
               cffa.Node(yyvsp[0].ln); 
               cffa.Point(0); 
            ;
    break;}
case 272:
{ yyval.ln = yyvsp[0].ln; ;
    break;}
case 273:
{ yyval.ln = FA_ANYMASK; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}



