#ifndef _UTILS_HPP_
#define _UTILS_HPP_
#include <stdlib.h>
#include <stdio.h>

#ifdef UNIX
#include <unistd.h>
#endif

#include <smapi/compiler.h>
#if defined(__WATCOMC__) && (defined(__OS2__) || defined(MSDOS))
/* Why it's not implemented in smapi/compiler.h? */
#define strcasecmp stricmp
#define strncasecmp strnicmp
#endif

void CheckMem(char *ptr);
int StrIsNum(char *Str);
int StrIsXNum(char *Str);
int DirExists(char *ptr);
int FileCopy(char *Dst, char *Src);
int FileMove(char *Dst, char *Src);
FILE *fcopen(char *Name, char *Mode);
int ExecP(char *Name);
int SetSemaphore(void);
int ReleaseSemaphore(void);

#ifdef UNIX
unsigned int filelength(int fh);
#endif
int tzoffset(void);
char *GetFilePath(char *Path, char *Name);
char *GetFileName(char *FName, char *Name);
void nls_strupr(char *s);
const char *dirslashbug(const char *dirname);

int fsCompareName(char *Name, char *Mask);

#if defined(__WATCOMC__) && defined(MSDOS)
extern "C" {
   void pascal far flush_handle2_(int fh);
}
#endif

#endif /* _UTILS_HPP_ */

